package de.mmadler.filecopy.gui;

import java.net.URL;
import java.util.ResourceBundle;

import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.layout.AnchorPane;
import javafx.stage.Stage;
import de.mmadler.filecopy.utils.OverwriteMode;

public class OverwriteController extends AnchorPane implements Initializable, IDialogController {
	public static final double dialogWidth = 385.0;
	public static final double dialogHeight = 160.0;
	
	private OverwriteMode _overwriteMode;
	private Stage _dialog;
	
	@FXML
	private Button fxFileOverwrite;
	@FXML
	private Label fxOverwriteDialogLabel;
	@FXML
	private CheckBox fxSetOverwriteMode;
	
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		fxOverwriteDialogLabel.setWrapText(true);
	}
	
	@Override
	public void setDialog(Stage dialog) {
		_dialog = dialog;
	}
	
	@Override
	public void setLabel(String text) {
		fxOverwriteDialogLabel.setText(text);
	}
	
	public void setDestinationWritable(boolean writable) {
		fxFileOverwrite.setDisable(!writable);
	}

	public OverwriteMode getOverwriteMode() {
		if(fxSetOverwriteMode.isSelected()) FileCopy.getConfig().setOverWriteMode(_overwriteMode);
		return _overwriteMode;
	}
	
	public void fxFileSkip() { _overwriteMode = OverwriteMode.Skip; _dialog.close(); }
	public void fxFileRename() { _overwriteMode = OverwriteMode.Rename; _dialog.close(); }
	public void fxFileOverwrite() { _overwriteMode = OverwriteMode.Overwrite; _dialog.close(); }

}
